package dev.shadowsoffire.apotheosis.ench.compat;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.google.common.collect.ImmutableList;
import com.google.common.collect.ImmutableMap;
import dev.shadowsoffire.apotheosis.Apoth;
import dev.shadowsoffire.apotheosis.Apotheosis;
import dev.shadowsoffire.apotheosis.ench.Ench;
import dev.shadowsoffire.apotheosis.ench.compat.EnchantingCategory;
import dev.shadowsoffire.apotheosis.ench.table.EnchantingRecipe;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import mezz.jei.api.IModPlugin;
import mezz.jei.api.JeiPlugin;
import mezz.jei.api.constants.RecipeTypes;
import mezz.jei.api.constants.VanillaTypes;
import mezz.jei.api.ingredients.IIngredientType;
import mezz.jei.api.recipe.RecipeType;
import mezz.jei.api.recipe.category.IRecipeCategory;
import mezz.jei.api.recipe.vanilla.IVanillaRecipeFactory;
import mezz.jei.api.registration.IRecipeCatalystRegistration;
import mezz.jei.api.registration.IRecipeCategoryRegistration;
import mezz.jei.api.registration.IRecipeRegistration;
import net.minecraft.client.Minecraft;
import net.minecraft.network.chat.Component;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.Items;
import net.minecraft.world.item.enchantment.EnchantmentHelper;
import net.minecraft.world.item.enchantment.Enchantments;
import net.minecraft.world.level.ItemLike;
import net.minecraft.world.level.block.Blocks;

@JeiPlugin
public class EnchJEIPlugin implements IModPlugin {
  public ResourceLocation getPluginUid() {
    return new ResourceLocation("apotheosis", "enchantment");
  }
  
  public void registerRecipes(IRecipeRegistration reg) {
    if (!Apotheosis.enableEnch)
      return; 
    ItemStack enchDiaSword = new ItemStack((ItemLike)Items.f_42388_);
    EnchantmentHelper.m_44865_((Map)ImmutableMap.of(Enchantments.f_44977_, Integer.valueOf(1)), enchDiaSword);
    ItemStack cursedDiaSword = new ItemStack((ItemLike)Items.f_42388_);
    EnchantmentHelper.m_44865_((Map)ImmutableMap.of(Enchantments.f_44975_, Integer.valueOf(1)), cursedDiaSword);
    ItemStack enchBook = new ItemStack((ItemLike)Items.f_42690_);
    EnchantmentHelper.m_44865_((Map)ImmutableMap.of(Enchantments.f_44977_, Integer.valueOf(1)), enchBook);
    IVanillaRecipeFactory factory = reg.getVanillaRecipeFactory();
    reg.addRecipes(RecipeTypes.ANVIL, (List)ImmutableList.of(factory
          .createAnvilRecipe(enchDiaSword, 
            
            (List)ImmutableList.of(new ItemStack((ItemLike)Blocks.f_50033_)), 
            (List)ImmutableList.of(new ItemStack((ItemLike)Items.f_42388_))), factory
          .createAnvilRecipe(cursedDiaSword, 
            
            (List)ImmutableList.of(new ItemStack((ItemLike)Ench.Items.PRISMATIC_WEB.get())), 
            (List)ImmutableList.of(new ItemStack((ItemLike)Items.f_42388_))), factory
          .createAnvilRecipe(enchDiaSword, 
            
            (List)ImmutableList.of(new ItemStack((ItemLike)Ench.Items.SCRAP_TOME.get())), 
            (List)ImmutableList.of(enchBook)), factory
          .createAnvilRecipe(new ItemStack((ItemLike)Blocks.f_50324_), 
            
            (List)ImmutableList.of(new ItemStack((ItemLike)Blocks.f_50075_)), 
            (List)ImmutableList.of(new ItemStack((ItemLike)Blocks.f_50322_)))));
    reg.addIngredientInfo(new ItemStack((ItemLike)Blocks.f_50201_), (IIngredientType)VanillaTypes.ITEM_STACK, new Component[] { (Component)Component.m_237115_("info.apotheosis.enchanting") });
    reg.addIngredientInfo(new ItemStack((ItemLike)Ench.Blocks.LIBRARY.get()), (IIngredientType)VanillaTypes.ITEM_STACK, new Component[] { (Component)Component.m_237115_("info.apotheosis.library") });
    List<EnchantingRecipe> recipes = new ArrayList<>((Minecraft.m_91087_()).f_91073_.m_7465_().m_44013_(Apoth.RecipeTypes.INFUSION));
    recipes.sort((r1, r2) -> Float.compare(r1.getRequirements().eterna(), r2.getRequirements().eterna()));
    reg.addRecipes(EnchantingCategory.TYPE, recipes);
  }
  
  public void registerRecipeCatalysts(IRecipeCatalystRegistration reg) {
    if (!Apotheosis.enableEnch)
      return; 
    reg.addRecipeCatalyst(new ItemStack((ItemLike)Blocks.f_50201_), new RecipeType[] { EnchantingCategory.TYPE });
  }
  
  public void registerCategories(IRecipeCategoryRegistration reg) {
    if (!Apotheosis.enableEnch)
      return; 
    reg.addRecipeCategories(new IRecipeCategory[] { (IRecipeCategory)new EnchantingCategory(reg.getJeiHelpers().getGuiHelper()) });
  }
}
